Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 567)
+++ lemon/Makefile.am	(revision 550)
@@ -13,5 +13,5 @@
 	lemon/lp_base.cc \
 	lemon/lp_skeleton.cc \
-	lemon/random.cc \
+        lemon/random.cc \
 	lemon/bits/windows.cc
 
@@ -22,6 +22,5 @@
 	$(CPLEX_CFLAGS) \
 	$(SOPLEX_CXXFLAGS) \
-	$(CLP_CXXFLAGS) \
-	$(CBC_CXXFLAGS)
+	$(CLP_CXXFLAGS)
 
 lemon_libemon_la_LDFLAGS = \
@@ -29,6 +28,5 @@
 	$(CPLEX_LIBS) \
 	$(SOPLEX_LIBS) \
-	$(CLP_LIBS) \
-	$(CBC_LIBS)
+	$(CLP_LIBS)
 
 if HAVE_GLPK
@@ -46,8 +44,4 @@
 if HAVE_CLP
 lemon_libemon_la_SOURCES += lemon/clp.cc
-endif
-
-if HAVE_CBC
-lemon_libemon_la_SOURCES += lemon/cbc.cc
 endif
 
Index: lemon/cbc.cc
===================================================================
--- lemon/cbc.cc	(revision 567)
+++ 	(revision )
@@ -1,460 +1,0 @@
-/* -*- mode: C++; indent-tabs-mode: nil; -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library.
- *
- * Copyright (C) 2003-2009
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
-///\file
-///\brief Implementation of the CBC MIP solver interface.
-
-#include "cbc.h"
-
-#include <coin/CoinModel.hpp>
-#include <coin/CbcModel.hpp>
-#include <coin/OsiSolverInterface.hpp>
-
-#ifdef COIN_HAS_CLP
-#include "coin/OsiClpSolverInterface.hpp"
-#endif
-#ifdef COIN_HAS_OSL
-#include "coin/OsiOslSolverInterface.hpp"
-#endif
-
-#include "coin/CbcCutGenerator.hpp"
-#include "coin/CbcHeuristicLocal.hpp"
-#include "coin/CbcHeuristicGreedy.hpp"
-#include "coin/CbcHeuristicFPump.hpp"
-#include "coin/CbcHeuristicRINS.hpp"
-
-#include "coin/CglGomory.hpp"
-#include "coin/CglProbing.hpp"
-#include "coin/CglKnapsackCover.hpp"
-#include "coin/CglOddHole.hpp"
-#include "coin/CglClique.hpp"
-#include "coin/CglFlowCover.hpp"
-#include "coin/CglMixedIntegerRounding.hpp"
-
-#include "coin/CbcHeuristic.hpp"
-
-namespace lemon {
-
-  CbcMip::CbcMip() {
-    _prob = new CoinModel();
-    _prob->setProblemName("LEMON");
-    _osi_solver = 0;
-    _cbc_model = 0;
-  }
-
-  CbcMip::CbcMip(const CbcMip& other) {
-    _prob = new CoinModel(*other._prob);
-    _osi_solver = 0;
-    _cbc_model = 0;
-  }
-
-  CbcMip::~CbcMip() {
-    delete _prob;
-    if (_osi_solver) delete _osi_solver;
-    if (_cbc_model) delete _cbc_model;
-  }
-
-  const char* CbcMip::_solverName() const { return "CbcMip"; }
-
-  int CbcMip::_addCol() {
-    _prob->addColumn(0, 0, 0, -COIN_DBL_MAX, COIN_DBL_MAX, 0.0, 0, false);
-    return _prob->numberColumns() - 1;
-  }
-
-  CbcMip* CbcMip::newSolver() const {
-    CbcMip* newlp = new CbcMip;
-    return newlp;
-  }
-
-  CbcMip* CbcMip::cloneSolver() const {
-    CbcMip* copylp = new CbcMip(*this);
-    return copylp;
-  }
-
-  int CbcMip::_addRow() {
-    _prob->addRow(0, 0, 0, -COIN_DBL_MAX, COIN_DBL_MAX);
-    return _prob->numberRows() - 1;
-  }
-
-
-  void CbcMip::_eraseCol(int i) {
-    _prob->deleteColumn(i);
-  }
-
-  void CbcMip::_eraseRow(int i) {
-    _prob->deleteRow(i);
-  }
-
-  void CbcMip::_eraseColId(int i) {
-    cols.eraseIndex(i);
-  }
-
-  void CbcMip::_eraseRowId(int i) {
-    rows.eraseIndex(i);
-  }
-
-  void CbcMip::_getColName(int c, std::string& name) const {
-    name = _prob->getColumnName(c);
-  }
-
-  void CbcMip::_setColName(int c, const std::string& name) {
-    _prob->setColumnName(c, name.c_str());
-  }
-
-  int CbcMip::_colByName(const std::string& name) const {
-    return _prob->column(name.c_str());
-  }
-
-  void CbcMip::_getRowName(int r, std::string& name) const {
-    name = _prob->getRowName(r);
-  }
-
-  void CbcMip::_setRowName(int r, const std::string& name) {
-    _prob->setRowName(r, name.c_str());
-  }
-
-  int CbcMip::_rowByName(const std::string& name) const {
-    return _prob->row(name.c_str());
-  }
-
-  void CbcMip::_setRowCoeffs(int i, ExprIterator b, ExprIterator e) {
-    for (ExprIterator it = b; it != e; ++it) {
-      _prob->setElement(i, it->first, it->second);
-    }
-  }
-
-  void CbcMip::_getRowCoeffs(int ix, InsertIterator b) const {
-    int length = _prob->numberRows();
-
-    std::vector<int> indices(length);
-    std::vector<Value> values(length);
-
-    length = _prob->getRow(ix, &indices[0], &values[0]);
-
-    for (int i = 0; i < length; ++i) {
-      *b = std::make_pair(indices[i], values[i]);
-      ++b;
-    }
-  }
-
-  void CbcMip::_setColCoeffs(int ix, ExprIterator b, ExprIterator e) {
-    for (ExprIterator it = b; it != e; ++it) {
-      _prob->setElement(it->first, ix, it->second);
-    }
-  }
-
-  void CbcMip::_getColCoeffs(int ix, InsertIterator b) const {
-    int length = _prob->numberColumns();
-
-    std::vector<int> indices(length);
-    std::vector<Value> values(length);
-
-    length = _prob->getColumn(ix, &indices[0], &values[0]);
-
-    for (int i = 0; i < length; ++i) {
-      *b = std::make_pair(indices[i], values[i]);
-      ++b;
-    }
-  }
-
-  void CbcMip::_setCoeff(int ix, int jx, Value value) {
-    _prob->setElement(ix, jx, value);
-  }
-
-  CbcMip::Value CbcMip::_getCoeff(int ix, int jx) const {
-    return _prob->getElement(ix, jx);
-  }
-
-
-  void CbcMip::_setColLowerBound(int i, Value lo) {
-    LEMON_ASSERT(lo != INF, "Invalid bound");
-    _prob->setColumnLower(i, lo == - INF ? - COIN_DBL_MAX : lo);
-  }
-
-  CbcMip::Value CbcMip::_getColLowerBound(int i) const {
-    double val = _prob->getColumnLower(i);
-    return val == - COIN_DBL_MAX ? - INF : val;
-  }
-
-  void CbcMip::_setColUpperBound(int i, Value up) {
-    LEMON_ASSERT(up != -INF, "Invalid bound");
-    _prob->setColumnUpper(i, up == INF ? COIN_DBL_MAX : up);
-  }
-
-  CbcMip::Value CbcMip::_getColUpperBound(int i) const {
-    double val = _prob->getColumnUpper(i);
-    return val == COIN_DBL_MAX ? INF : val;
-  }
-
-  void CbcMip::_setRowLowerBound(int i, Value lo) {
-    LEMON_ASSERT(lo != INF, "Invalid bound");
-    _prob->setRowLower(i, lo == - INF ? - COIN_DBL_MAX : lo);
-  }
-
-  CbcMip::Value CbcMip::_getRowLowerBound(int i) const {
-    double val = _prob->getRowLower(i);
-    return val == - COIN_DBL_MAX ? - INF : val;
-  }
-
-  void CbcMip::_setRowUpperBound(int i, Value up) {
-    LEMON_ASSERT(up != -INF, "Invalid bound");
-    _prob->setRowUpper(i, up == INF ? COIN_DBL_MAX : up);
-  }
-
-  CbcMip::Value CbcMip::_getRowUpperBound(int i) const {
-    double val = _prob->getRowUpper(i);
-    return val == COIN_DBL_MAX ? INF : val;
-  }
-
-  void CbcMip::_setObjCoeffs(ExprIterator b, ExprIterator e) {
-    int num = _prob->numberColumns();
-    for (int i = 0; i < num; ++i) {
-      _prob->setColumnObjective(i, 0.0);
-    }
-    for (ExprIterator it = b; it != e; ++it) {
-      _prob->setColumnObjective(it->first, it->second);
-    }
-  }
-
-  void CbcMip::_getObjCoeffs(InsertIterator b) const {
-    int num = _prob->numberColumns();
-    for (int i = 0; i < num; ++i) {
-      Value coef = _prob->getColumnObjective(i);
-      if (coef != 0.0) {
-        *b = std::make_pair(i, coef);
-        ++b;
-      }
-    }
-  }
-
-  void CbcMip::_setObjCoeff(int i, Value obj_coef) {
-    _prob->setColumnObjective(i, obj_coef);
-  }
-
-  CbcMip::Value CbcMip::_getObjCoeff(int i) const {
-    return _prob->getColumnObjective(i);
-  }
-
-  CbcMip::SolveExitStatus CbcMip::_solve() {
-
-    if (_osi_solver) {
-      delete _osi_solver;
-    }
-#ifdef COIN_HAS_CLP
-    _osi_solver = new OsiClpSolverInterface();
-#elif COIN_HAS_OSL
-    _osi_solver = new OsiOslSolverInterface();
-#else
-#error Cannot instantiate Osi solver
-#endif
-
-    _osi_solver->loadFromCoinModel(*_prob);
-
-    if (_cbc_model) {
-      delete _cbc_model;
-    }
-    _cbc_model= new CbcModel(*_osi_solver);
-
-    switch (_message_level) {
-    case MESSAGE_NO_OUTPUT:
-      _osi_solver->messageHandler()->setLogLevel(0);
-      _cbc_model->setLogLevel(0);
-      break;
-    case MESSAGE_ERROR_MESSAGE:
-      _osi_solver->messageHandler()->setLogLevel(1);
-      _cbc_model->setLogLevel(1);
-      break;
-    case MESSAGE_NORMAL_OUTPUT:
-      _osi_solver->messageHandler()->setLogLevel(2);
-      _cbc_model->setLogLevel(2);
-      break;
-    case MESSAGE_FULL_OUTPUT:
-      _osi_solver->messageHandler()->setLogLevel(3);
-      _cbc_model->setLogLevel(3);
-      break;
-    }
-
-    _cbc_model->initialSolve();
-    _cbc_model->solver()->setHintParam(OsiDoReducePrint, true, OsiHintTry);
-
-    if (!_cbc_model->isInitialSolveAbandoned() &&
-        _cbc_model->isInitialSolveProvenOptimal() &&
-        !_cbc_model->isInitialSolveProvenPrimalInfeasible() &&
-        !_cbc_model->isInitialSolveProvenDualInfeasible()) {
-
-      CglProbing generator1;
-      generator1.setUsingObjective(true);
-      generator1.setMaxPass(3);
-      generator1.setMaxProbe(100);
-      generator1.setMaxLook(50);
-      generator1.setRowCuts(3);
-      _cbc_model->addCutGenerator(&generator1, -1, "Probing");
-
-      CglGomory generator2;
-      generator2.setLimit(300);
-      _cbc_model->addCutGenerator(&generator2, -1, "Gomory");
-
-      CglKnapsackCover generator3;
-      _cbc_model->addCutGenerator(&generator3, -1, "Knapsack");
-
-      CglOddHole generator4;
-      generator4.setMinimumViolation(0.005);
-      generator4.setMinimumViolationPer(0.00002);
-      generator4.setMaximumEntries(200);
-      _cbc_model->addCutGenerator(&generator4, -1, "OddHole");
-
-      CglClique generator5;
-      generator5.setStarCliqueReport(false);
-      generator5.setRowCliqueReport(false);
-      _cbc_model->addCutGenerator(&generator5, -1, "Clique");
-
-      CglMixedIntegerRounding mixedGen;
-      _cbc_model->addCutGenerator(&mixedGen, -1, "MixedIntegerRounding");
-
-      CglFlowCover flowGen;
-      _cbc_model->addCutGenerator(&flowGen, -1, "FlowCover");
-
-#ifdef COIN_HAS_CLP
-      OsiClpSolverInterface* osiclp =
-        dynamic_cast<OsiClpSolverInterface*>(_cbc_model->solver());
-      if (osiclp->getNumRows() < 300 && osiclp->getNumCols() < 500) {
-        osiclp->setupForRepeatedUse(2, 0);
-      }
-#endif
-
-      CbcRounding heuristic1(*_cbc_model);
-      heuristic1.setWhen(3);
-      _cbc_model->addHeuristic(&heuristic1);
-
-      CbcHeuristicLocal heuristic2(*_cbc_model);
-      heuristic2.setWhen(3);
-      _cbc_model->addHeuristic(&heuristic2);
-
-      CbcHeuristicGreedyCover heuristic3(*_cbc_model);
-      heuristic3.setAlgorithm(11);
-      heuristic3.setWhen(3);
-      _cbc_model->addHeuristic(&heuristic3);
-
-      CbcHeuristicFPump heuristic4(*_cbc_model);
-      heuristic4.setWhen(3);
-      _cbc_model->addHeuristic(&heuristic4);
-
-      CbcHeuristicRINS heuristic5(*_cbc_model);
-      heuristic5.setWhen(3);
-      _cbc_model->addHeuristic(&heuristic5);
-
-      if (_cbc_model->getNumCols() < 500) {
-        _cbc_model->setMaximumCutPassesAtRoot(-100);
-      } else if (_cbc_model->getNumCols() < 5000) {
-        _cbc_model->setMaximumCutPassesAtRoot(100);
-      } else {
-        _cbc_model->setMaximumCutPassesAtRoot(20);
-      }
-
-      if (_cbc_model->getNumCols() < 5000) {
-        _cbc_model->setNumberStrong(10);
-      }
-
-      _cbc_model->solver()->setIntParam(OsiMaxNumIterationHotStart, 100);
-      _cbc_model->branchAndBound();
-    }
-
-    if (_cbc_model->isAbandoned()) {
-      return UNSOLVED;
-    } else {
-      return SOLVED;
-    }
-  }
-
-  CbcMip::Value CbcMip::_getSol(int i) const {
-    return _cbc_model->getColSolution()[i];
-  }
-
-  CbcMip::Value CbcMip::_getSolValue() const {
-    return _cbc_model->getObjValue();
-  }
-
-  CbcMip::ProblemType CbcMip::_getType() const {
-    if (_cbc_model->isProvenOptimal()) {
-      return OPTIMAL;
-    } else if (_cbc_model->isContinuousUnbounded()) {
-      return UNBOUNDED;
-    }
-    return FEASIBLE;
-  }
-
-  void CbcMip::_setSense(Sense sense) {
-    switch (sense) {
-    case MIN:
-      _prob->setOptimizationDirection(1.0);
-      break;
-    case MAX:
-      _prob->setOptimizationDirection(- 1.0);
-      break;
-    }
-  }
-
-  CbcMip::Sense CbcMip::_getSense() const {
-    if (_prob->optimizationDirection() > 0.0) {
-      return MIN;
-    } else if (_prob->optimizationDirection() < 0.0) {
-      return MAX;
-    } else {
-      LEMON_ASSERT(false, "Wrong sense");
-      return CbcMip::Sense();
-    }
-  }
-
-  void CbcMip::_setColType(int i, CbcMip::ColTypes col_type) {
-    switch (col_type){
-    case INTEGER:
-      _prob->setInteger(i);
-      break;
-    case REAL:
-      _prob->setContinuous(i);
-      break;
-    default:;
-      LEMON_ASSERT(false, "Wrong sense");
-    }
-  }
-
-  CbcMip::ColTypes CbcMip::_getColType(int i) const {
-    return _prob->getColumnIsInteger(i) ? INTEGER : REAL;
-  }
-
-  void CbcMip::_clear() {
-    delete _prob;
-    if (_osi_solver) {
-      delete _osi_solver;
-      _osi_solver = 0;
-    }
-    if (_cbc_model) {
-      delete _cbc_model;
-      _cbc_model = 0;
-    }
-
-    _prob = new CoinModel();
-    rows.clear();
-    cols.clear();
-  }
-
-  void CbcMip::messageLevel(MessageLevel m) {
-    _message_level = m;
-  }
-
-} //END OF NAMESPACE LEMON
Index: lemon/cbc.h
===================================================================
--- lemon/cbc.h	(revision 567)
+++ 	(revision )
@@ -1,150 +1,0 @@
-/* -*- mode: C++; indent-tabs-mode: nil; -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library.
- *
- * Copyright (C) 2003-2009
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
-// -*- C++ -*-
-#ifndef LEMON_CBC_H
-#define LEMON_CBC_H
-
-///\file
-///\brief Header of the LEMON-CBC mip solver interface.
-///\ingroup lp_group
-
-#include <lemon/lp_base.h>
-
-class CoinModel;
-class OsiSolverInterface;
-class CbcModel;
-
-namespace lemon {
-
-  /// \brief Interface for the CBC MIP solver
-  ///
-  /// This class implements an interface for the CBC MIP solver.
-  ///\ingroup lp_group
-  class CbcMip : public MipSolver {
-  protected:
-
-    CoinModel *_prob;
-    OsiSolverInterface *_osi_solver;
-    CbcModel *_cbc_model;
-
-  public:
-
-    /// \e
-    CbcMip();
-    /// \e
-    CbcMip(const CbcMip&);
-    /// \e
-    ~CbcMip();
-    /// \e
-    virtual CbcMip* newSolver() const;
-    /// \e
-    virtual CbcMip* cloneSolver() const;
-
-  protected:
-
-    virtual const char* _solverName() const;
-
-    virtual int _addCol();
-    virtual int _addRow();
-
-    virtual void _eraseCol(int i);
-    virtual void _eraseRow(int i);
-
-    virtual void _eraseColId(int i);
-    virtual void _eraseRowId(int i);
-
-    virtual void _getColName(int col, std::string& name) const;
-    virtual void _setColName(int col, const std::string& name);
-    virtual int _colByName(const std::string& name) const;
-
-    virtual void _getRowName(int row, std::string& name) const;
-    virtual void _setRowName(int row, const std::string& name);
-    virtual int _rowByName(const std::string& name) const;
-
-    virtual void _setRowCoeffs(int i, ExprIterator b, ExprIterator e);
-    virtual void _getRowCoeffs(int i, InsertIterator b) const;
-
-    virtual void _setColCoeffs(int i, ExprIterator b, ExprIterator e);
-    virtual void _getColCoeffs(int i, InsertIterator b) const;
-
-    virtual void _setCoeff(int row, int col, Value value);
-    virtual Value _getCoeff(int row, int col) const;
-
-    virtual void _setColLowerBound(int i, Value value);
-    virtual Value _getColLowerBound(int i) const;
-    virtual void _setColUpperBound(int i, Value value);
-    virtual Value _getColUpperBound(int i) const;
-
-    virtual void _setRowLowerBound(int i, Value value);
-    virtual Value _getRowLowerBound(int i) const;
-    virtual void _setRowUpperBound(int i, Value value);
-    virtual Value _getRowUpperBound(int i) const;
-
-    virtual void _setObjCoeffs(ExprIterator b, ExprIterator e);
-    virtual void _getObjCoeffs(InsertIterator b) const;
-
-    virtual void _setObjCoeff(int i, Value obj_coef);
-    virtual Value _getObjCoeff(int i) const;
-
-    virtual void _setSense(Sense sense);
-    virtual Sense _getSense() const;
-
-    virtual ColTypes _getColType(int col) const;
-    virtual void _setColType(int col, ColTypes col_type);
-
-    virtual SolveExitStatus _solve();
-    virtual ProblemType _getType() const;
-    virtual Value _getSol(int i) const;
-    virtual Value _getSolValue() const;
-
-    virtual void _clear();
-
-  public:
-
-    ///Enum for \c messageLevel() parameter
-    enum MessageLevel {
-      /// no output (default value)
-      MESSAGE_NO_OUTPUT = 0,
-      /// error messages only
-      MESSAGE_ERROR_MESSAGE = 1,
-      /// normal output
-      MESSAGE_NORMAL_OUTPUT = 2,
-      /// full output (includes informational messages)
-      MESSAGE_FULL_OUTPUT = 3
-    };
-
-  private:
-
-    MessageLevel _message_level;
-
-  public:
-
-    ///Set the verbosity of the messages
-
-    ///Set the verbosity of the messages
-    ///
-    ///\param m is the level of the messages output by the solver routines.
-    void messageLevel(MessageLevel m);
-
-
-  };
-
-}
-
-#endif
Index: lemon/config.h.in
===================================================================
--- lemon/config.h.in	(revision 567)
+++ lemon/config.h.in	(revision 517)
@@ -19,5 +19,2 @@
 /* Define to 1 if you have CLP */
 #undef HAVE_CLP
-
-/* Define to 1 if you have CBC */
-#undef HAVE_CBC
Index: lemon/glpk.cc
===================================================================
--- lemon/glpk.cc	(revision 566)
+++ lemon/glpk.cc	(revision 551)
@@ -534,5 +534,4 @@
     : LpBase(), LpSolver(), GlpkBase() {
     messageLevel(MESSAGE_NO_OUTPUT);
-    presolver(false);
   }
 
@@ -540,5 +539,4 @@
     : LpBase(other), LpSolver(other), GlpkBase(other) {
     messageLevel(MESSAGE_NO_OUTPUT);
-    presolver(false);
   }
 
@@ -577,23 +575,6 @@
       break;
     }
-    smcp.presolve = _presolve;
-
-    // If the basis is not valid we get an error return value.
-    // In this case we can try to create a new basis.
-    switch (glp_simplex(lp, &smcp)) {
-    case 0:
-      break;
-    case GLP_EBADB:
-    case GLP_ESING:
-    case GLP_ECOND:
-      glp_term_out(false);
-      glp_adv_basis(lp, 0);
-      glp_term_out(true);
-      if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
-      break;
-    default:
-      return UNSOLVED;
-    }
-
+
+    if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
     return SOLVED;
   }
@@ -620,22 +601,6 @@
     }
     smcp.meth = GLP_DUAL;
-    smcp.presolve = _presolve;
-
-    // If the basis is not valid we get an error return value.
-    // In this case we can try to create a new basis.
-    switch (glp_simplex(lp, &smcp)) {
-    case 0:
-      break;
-    case GLP_EBADB:
-    case GLP_ESING:
-    case GLP_ECOND:
-      glp_term_out(false);
-      glp_adv_basis(lp, 0);
-      glp_term_out(true);
-      if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
-      break;
-    default:
-      return UNSOLVED;
-    }
+
+    if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
     return SOLVED;
   }
@@ -855,6 +820,6 @@
   }
 
-  void GlpkLp::presolver(bool presolve) {
-    _presolve = presolve;
+  void GlpkLp::presolver(bool b) {
+    lpx_set_int_parm(lp, LPX_K_PRESOL, b ? 1 : 0);
   }
 
@@ -917,21 +882,5 @@
     smcp.meth = GLP_DUAL;
 
-    // If the basis is not valid we get an error return value.
-    // In this case we can try to create a new basis.
-    switch (glp_simplex(lp, &smcp)) {
-    case 0:
-      break;
-    case GLP_EBADB:
-    case GLP_ESING:
-    case GLP_ECOND:
-      glp_term_out(false);
-      glp_adv_basis(lp, 0);
-      glp_term_out(true);
-      if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
-      break;
-    default:
-      return UNSOLVED;
-    }
-
+    if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
     if (glp_get_status(lp) != GLP_OPT) return SOLVED;
 
Index: lemon/glpk.h
===================================================================
--- lemon/glpk.h	(revision 565)
+++ lemon/glpk.h	(revision 542)
@@ -179,10 +179,4 @@
     SolveExitStatus solveDual();
 
-  private:
-
-    bool _presolve;
-
-  public:
-
     ///Turns on or off the presolver
 
@@ -190,5 +184,5 @@
     ///
     ///The presolver is off by default.
-    void presolver(bool presolve);
+    void presolver(bool b);
 
     ///Enum for \c messageLevel() parameter
Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 559)
+++ lemon/maps.h	(revision 572)
@@ -1833,5 +1833,5 @@
   /// \c GR::Edge).
   ///
-  /// \see DescriptorMap
+  /// \see RangeIdMap
   template <typename GR, typename K>
   class IdMap : public MapBase<K, int> {
@@ -1899,5 +1899,5 @@
 
 
-  /// \brief General invertable graph map type.
+  /// \brief General cross reference graph map type.
 
   /// This class provides simple invertable graph maps.
@@ -1916,5 +1916,5 @@
   /// \see IterableValueMap
   template <typename GR, typename K, typename V>
-  class InvertableMap
+  class CrossRefMap
     : protected ItemSetTraits<GR, K>::template Map<V>::Type {
   private:
@@ -1928,17 +1928,17 @@
   public:
 
-    /// The graph type of InvertableMap.
+    /// The graph type of CrossRefMap.
     typedef GR Graph;
-    /// The key type of InvertableMap (\c Node, \c Arc or \c Edge).
+    /// The key type of CrossRefMap (\c Node, \c Arc or \c Edge).
     typedef K Item;
-    /// The key type of InvertableMap (\c Node, \c Arc or \c Edge).
+    /// The key type of CrossRefMap (\c Node, \c Arc or \c Edge).
     typedef K Key;
-    /// The value type of InvertableMap.
+    /// The value type of CrossRefMap.
     typedef V Value;
 
     /// \brief Constructor.
     ///
-    /// Construct a new InvertableMap for the given graph.
-    explicit InvertableMap(const Graph& graph) : Map(graph) {}
+    /// Construct a new CrossRefMap for the given graph.
+    explicit CrossRefMap(const Graph& graph) : Map(graph) {}
 
     /// \brief Forward iterator for values.
@@ -1949,5 +1949,5 @@
     class ValueIterator
       : public std::iterator<std::forward_iterator_tag, Value> {
-      friend class InvertableMap;
+      friend class CrossRefMap;
     private:
       ValueIterator(typename Container::const_iterator _it)
@@ -2073,11 +2073,11 @@
       ///
       /// Constructor of the InverseMap.
-      explicit InverseMap(const InvertableMap& inverted)
+      explicit InverseMap(const CrossRefMap& inverted)
         : _inverted(inverted) {}
 
       /// The value type of the InverseMap.
-      typedef typename InvertableMap::Key Value;
+      typedef typename CrossRefMap::Key Value;
       /// The key type of the InverseMap.
-      typedef typename InvertableMap::Value Key;
+      typedef typename CrossRefMap::Value Key;
 
       /// \brief Subscript operator.
@@ -2090,5 +2090,5 @@
 
     private:
-      const InvertableMap& _inverted;
+      const CrossRefMap& _inverted;
     };
 
@@ -2102,16 +2102,15 @@
   };
 
-  /// \brief Provides a mutable, continuous and unique descriptor for each
-  /// item in a graph.
-  ///
-  /// DescriptorMap provides a unique and continuous (but mutable)
-  /// descriptor (id) for each item of the same type (\c Node, \c Arc or
+  /// \brief Provides continuous and unique ID for the
+  /// items of a graph.
+  ///
+  /// RangeIdMap provides a unique and continuous
+  /// ID for each item of a given type (\c Node, \c Arc or
   /// \c Edge) in a graph. This id is
   ///  - \b unique: different items get different ids,
   ///  - \b continuous: the range of the ids is the set of integers
   ///    between 0 and \c n-1, where \c n is the number of the items of
-  ///    this type (\c Node, \c Arc or \c Edge). So the id of an item can
-  ///    change if you delete an other item of the same type, i.e. this
-  ///    id is mutable.
+  ///    this type (\c Node, \c Arc or \c Edge).
+  ///  - So, the ids can change when deleting an item of the same type.
   ///
   /// Thus this id is not (necessarily) the same as what can get using
@@ -2126,5 +2125,5 @@
   /// \see IdMap
   template <typename GR, typename K>
-  class DescriptorMap
+  class RangeIdMap
     : protected ItemSetTraits<GR, K>::template Map<int>::Type {
 
@@ -2132,17 +2131,17 @@
 
   public:
-    /// The graph type of DescriptorMap.
+    /// The graph type of RangeIdMap.
     typedef GR Graph;
-    /// The key type of DescriptorMap (\c Node, \c Arc or \c Edge).
+    /// The key type of RangeIdMap (\c Node, \c Arc or \c Edge).
     typedef K Item;
-    /// The key type of DescriptorMap (\c Node, \c Arc or \c Edge).
+    /// The key type of RangeIdMap (\c Node, \c Arc or \c Edge).
     typedef K Key;
-    /// The value type of DescriptorMap.
+    /// The value type of RangeIdMap.
     typedef int Value;
 
     /// \brief Constructor.
     ///
-    /// Constructor for descriptor map.
-    explicit DescriptorMap(const Graph& gr) : Map(gr) {
+    /// Constructor.
+    explicit RangeIdMap(const Graph& gr) : Map(gr) {
       Item it;
       const typename Map::Notifier* nf = Map::notifier();
@@ -2245,14 +2244,14 @@
     }
 
-    /// \brief Gives back the \e descriptor of the item.
-    ///
-    /// Gives back the mutable and unique \e descriptor of the map.
+    /// \brief Gives back the \e RangeId of the item
+    ///
+    /// Gives back the \e RangeId of the item.
     int operator[](const Item& item) const {
       return Map::operator[](item);
     }
 
-    /// \brief Gives back the item by its descriptor.
-    ///
-    /// Gives back th item by its descriptor.
+    /// \brief Gives back the item belonging to a \e RangeId
+    /// 
+    /// Gives back the item belonging to a \e RangeId.
     Item operator()(int id) const {
       return _inv_map[id];
@@ -2266,7 +2265,7 @@
   public:
 
-    /// \brief The inverse map type of DescriptorMap.
-    ///
-    /// The inverse map type of DescriptorMap.
+    /// \brief The inverse map type of RangeIdMap.
+    ///
+    /// The inverse map type of RangeIdMap.
     class InverseMap {
     public:
@@ -2274,12 +2273,12 @@
       ///
       /// Constructor of the InverseMap.
-      explicit InverseMap(const DescriptorMap& inverted)
+      explicit InverseMap(const RangeIdMap& inverted)
         : _inverted(inverted) {}
 
 
       /// The value type of the InverseMap.
-      typedef typename DescriptorMap::Key Value;
+      typedef typename RangeIdMap::Key Value;
       /// The key type of the InverseMap.
-      typedef typename DescriptorMap::Value Key;
+      typedef typename RangeIdMap::Value Key;
 
       /// \brief Subscript operator.
@@ -2299,5 +2298,5 @@
 
     private:
-      const DescriptorMap& _inverted;
+      const RangeIdMap& _inverted;
     };
 
